#include "unix_sockets.h"

#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

int unix_socket_client_start(char *sock_path) {
  struct sockaddr_un addr;

  // Create a new client socket with domain: AF_UNIX, type: SOCK_STREAM, protocol: 0
  int sfd = socket(AF_UNIX, SOCK_STREAM, 0);

  // Make sure socket's file descriptor is legit.
  if (sfd == -1) {
    fprintf(stderr,"ERROR: socket is not legit\n");
    return -1;
  }

  //
  // Construct server address, and make the connection.
  //
  memset(&addr, 0, sizeof(struct sockaddr_un));
  addr.sun_family = AF_UNIX;
  strncpy(addr.sun_path, sock_path, sizeof(addr.sun_path) - 1);

  // Connects the active socket referred to be sfd to the listening socket
  // whose address is specified by addr.
  if (connect(sfd, (struct sockaddr *) &addr, sizeof(struct sockaddr_un)) == -1) {
    fprintf(stderr,"ERROR: Failed to connect to socket\n");
    return -1;
  }

  return sfd;
}